<template>
    <div style="margin: 0; width: 100%">
        <template v-if="getPhotos.isLoading === false">
            <head-two :title="isLang.photos.head"/>
            <div style="margin: 0; height: 65px;"></div>
            <img-grid />
            <gallery-foot />
            <layout-btn />
        </template>
        <template v-else>
            <div class="loading centered bg-night blinking-txt-prime brand">
                Un instant...
            </div>
        </template>
    </div>
</template>

<script setup lang="ts">
import { onMounted, defineAsyncComponent, onUnmounted } from 'vue';
import { useRouter } from 'vue-router';
import langStore from '../store/langStore';
import { IPhoto} from '../interfaces';
import photoStore from '../store/photoStore';
import HeadTwo from '../components/HeadTwo.vue';
import ImgGrid from '../components/ImgGrid.vue';
import LayoutBtn from '../components/LayoutBtn.vue';

const GalleryFoot = defineAsyncComponent(() => import('../components/GalleryFoot.vue'));

const { currentRoute } = useRouter();
const { isLang } = langStore;
const { clAll, clPay, clPor, getPhotos } = photoStore;

onMounted(async (): Promise<void> => {
    if (currentRoute.value.params.layout === 'portrait') {
        getPhotos.value.list = await clPor();
        if(getPhotos.value.list.length > 1) {
            getPhotos.value.isLoading = false;
        }
    } else if (currentRoute.value.params.layout === 'paysage') {
        getPhotos.value.list = await clPay();
        if(getPhotos.value.list.length > 1) {
            getPhotos.value.isLoading = false;
        }
    } else {
        getPhotos.value.list = await clAll();
        if(getPhotos.value.list.length > 1) {
            getPhotos.value.isLoading = false;
        }
    }
})

onUnmounted(() => {
    getPhotos.value.list = [] as IPhoto[];
    getPhotos.value.isLoading = true;
})

</script>

<style scoped>
.loading {
    margin: 0;
    height: 100vh;
    width: 100%;
}
</style>